<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>
    <script src="utils.js"></script>

    <link rel="import" href="../dez-canvas.html">
  </head>
  <body>

    <test-fixture id="WithGrobFixture">
      <template>
        <dez-canvas
            grobs-data='[
                {"type": "Rectangle", "text": "0", "x": 200, "lg": 300, "color": "", "lines": [0]}
            ]'
        ></dez-canvas>
      </template>
    </test-fixture>

    <test-fixture id="WithBgAndGrobFixture">
      <template>
        <dez-canvas
            bg="../demo/magritte.jpg"
            grobs-data='[
                {"type": "Rectangle", "text": "0", "x": 200, "lg": 300, "color": "", "lines": [0]}
            ]'
        ></dez-canvas>
      </template>
    </test-fixture>

    <test-fixture id="WithGrobAndOneLineGridFixture">
      <template>
        <dez-canvas
            grobs-data='[
                {"type": "Rectangle", "text": "0", "x": 200, "lg": 300, "color": "", "lines": [0]}
            ]'
            grid-data= '{
                "lines": [
                    {"bottom" : 100.0, "top": 55.0}
                ]
            }'
        ></dez-canvas>
      </template>
    </test-fixture>

    <test-fixture id="WithGrobAndGridFixture">
      <template>
        <dez-canvas
            grobs-data='[
                {"type": "Rectangle", "text": "0", "x": 200, "lg": 300, "color": "", "lines": [1,3]}
            ]'
            grid-data= '{
                "lines": [
                    {"bottom" : 100.0, "top": 5.0},
                    {"bottom" : 200.0, "top": 105.0},
                    {"bottom" : 300.0, "top": 205.0},
                    {"bottom" : 400.0, "top": 305.0}
                ]
            }'
        ></dez-canvas>
      </template>
    </test-fixture>

    <test-fixture id="WithOneLineGrobAndGridFixture">
      <template>
        <dez-canvas
            grobs-data='[
                {"type": "Rectangle", "text": "0", "x": 200, "lg": 300, "color": "", "lines": [2]}
            ]'
            grid-data= '{
                "lines": [
                    {"bottom" : 100.0, "top": 5.0},
                    {"bottom" : 200.0, "top": 105.0},
                    {"bottom" : 300.0, "top": 205.0},
                    {"bottom" : 400.0, "top": 305.0}
                ]
            }'
        ></dez-canvas>
      </template>
    </test-fixture>

    <script>

    const LINE_HEIGHT = 30
    const INTERLINE = 2
    const NB_TOP_LINES = 3

    suite ('Grob defined tests', function () {

      setup (function() {
        this.timeout = 100;
        this._topHeight = (LINE_HEIGHT + INTERLINE) * NB_TOP_LINES
      })

        test ('without grid, grobs should lay on the entire height of the svg', function (done) {
            let element = fixture ("WithGrobFixture");
            setTimeout(function () {
                let rectElement = element.shadowRoot.querySelector('svg>g>rect');
                assert.equal(rectElement.getAttribute("height"), 200);
                done();
            }, this.timeout);
        });

        test ('no grid, with background, grobs should lay on the entire height of the background', function (done) {
            let element = fixture ("WithBgAndGrobFixture");
            setTimeout(function () {
                let rectElement = element.shadowRoot.querySelector('svg>g>rect');
                assert.equal(rectElement.getAttribute("height"), 300);
                done();
            }, this.timeout);
        });

        test ('with unique line grid; grobs should lay on the entire line height', function (done) {
            let element = fixture ("WithGrobAndOneLineGridFixture");
            setTimeout(() => {
                let rectElement = element.shadowRoot.querySelector('svg>g>rect');
                assert.equal(rectElement.getAttribute("y"), 80 + this._topHeight);
                assert.equal(rectElement.getAttribute("height"), 45);
                done();
            }, this.timeout);
        });

        test ('with several lines grid, several lines grobs should lay on several lines', function (done) {
            let element = fixture ("WithGrobAndGridFixture");
            setTimeout(() => {
                let rectElement = element.shadowRoot.querySelector('svg>g>rect');
                assert.equal(rectElement.getAttribute("y"), 130 + this._topHeight);
                assert.equal(rectElement.getAttribute("height"), 295);
                done();
            }, this.timeout);
        });

        test ('with several lines grid, unique line grobs should lay on only line', function (done) {
            let element = fixture ("WithOneLineGrobAndGridFixture");
            setTimeout(() => {
                let rectElement = element.shadowRoot.querySelector('svg>g>rect');
                assert.equal(rectElement.getAttribute("y"), 230  + this._topHeight);
                assert.equal(rectElement.getAttribute("height"), '95');
                done();
            }, this.timeout);
        });

    });

    </script>

  </body>
</html>
